import 'package:cramr_ui_lib/model/verb_test_model.dart';
import 'package:cramr_ui_lib/routes/verb_indicative_study_form.dart';
import 'package:cramr_ui_lib/theme/custom_theme.dart';
import 'package:flutter/material.dart';
import 'package:provider/provider.dart';

/// The Route that allows you to study the indicative of the verb
class VerbIndicativeStudyRoute extends StatelessWidget {

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: "Verbomatique",
      theme: CustomTheme.lightTheme,
      home: SafeArea(
        key: UniqueKey(),
        child: Scaffold(
          appBar: AppBar(
            title: _titleCell(context),
            actions: [
              _homeIcon(context),
            ],
          ),
          body: Container(
              key: UniqueKey(),
              child: VerbIndicativeStudyForm()),
          floatingActionButton: FloatingActionButton(
            key: Key('forward_button'),
            onPressed: () {
              Navigator.pushNamed(context, '/verbIndicativeTestRoute');
            },
            child: Icon(Icons.arrow_forward),
          ),
        ),
      ),
    );
  }

  IconButton _homeIcon(BuildContext context) {
    return IconButton(
        key: Key('home_button'),
        onPressed: () {
          Navigator.restorablePopAndPushNamed(context, '/verbSelectionRoute');
        },
        icon: Icon(Icons.home));
  }

  Widget _titleCell(BuildContext context) {
    return Consumer<VerbTestModel>(builder: (context, testModel, child) {
      return Text(
        "Vervoeging ${testModel.verb.infinitive}",
        key: Key("Vervoeging ${testModel.verb.infinitive}"),
      );
    });
  }

}