import 'package:cramr_ui_lib/model/verb_test_model.dart';
import 'package:cramr_ui_lib/routes/verb_indicative_evaluate_route.dart';
import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:provider/provider.dart';

var expected = ['expect-p0', 'expect-p1', 'expect-p2', 'expect-p3', 'expect-p4', 'expect-p5'];
var pronouns = ['p0', 'p1', 'p2', 'p3', 'p4', 'p5'];
var targetLanguageIso = 'zz';
var infinitive = 'infinitive';
var translation = 'translation';

Widget createVerbIndicativeEvaluateRoute() => ChangeNotifierProvider<VerbTestModel> (
  create: (context) {
    var notifier = VerbTestModel();
    notifier.initialise(expected, pronouns, targetLanguageIso, infinitive, translation);
    int i = 0;
    expected.forEach((element) {
      notifier.add(element, i++);
    });
    return notifier;
  },
  child: VerbIndicativeEvaluateRoute(),
);

void main() {
  testWidgets('Find elements on screen', (WidgetTester tester) async {
    await tester.pumpWidget(createVerbIndicativeEvaluateRoute());

    Finder scoreTitleFinder = find.text('Score:');
    expect(scoreTitleFinder, findsOneWidget);

    Finder scoreFinder = find.text('6/6');
    expect(scoreFinder, findsOneWidget);

    pronouns.forEach((element) {
      final Finder pronounFinder = find.text(element);
      expect(pronounFinder, findsOneWidget);
    });

    expected.forEach((element) {
      final Finder expectedTextFinder = find.text(element);
      expect(expectedTextFinder, findsOneWidget);
    });

    //TODO: add testing with errors

  });
}