import 'package:cramr_ui_lib/model/verb_test_model.dart';
import 'package:cramr_ui_lib/routes/verb_indicative_study_route.dart';
import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:provider/provider.dart';


//TODO: introduce mocking
var expected = ['expect-p0', 'expect-p1', 'expect-p2', 'expect-p3', 'expect-p4', 'expect-p5'];
var pronouns = ['p0', 'p1', 'p2', 'p3', 'p4', 'p5'];
var targetLanguageIso = 'zz';
var infinitive = 'infinitive';
var translation = 'translation';

Widget createVerbIndicativeStudyRoute() => ChangeNotifierProvider<VerbTestModel> (
  create: (context) {
    var notifier = VerbTestModel();
    notifier.initialise(expected, pronouns, targetLanguageIso, infinitive, translation);
    return notifier;
  },
  child: VerbIndicativeStudyRoute(),
);

void main() {
  testWidgets('Find elements on screen', (WidgetTester tester) async {
    await tester.pumpWidget(createVerbIndicativeStudyRoute());

    pronouns.forEach((element) {
      final Finder pronounFieldFinder = find.byKey(Key(element));
      expect(pronounFieldFinder, findsOneWidget);
    });

    for (int i = 0; i < pronouns.length; i++) {
      final Finder coverKeyFinder = find.byKey(Key('cover_${infinitive}_${i}'));
      expect(coverKeyFinder, findsOneWidget);
      await tester.tap(coverKeyFinder);
    }

  });
}