//TODO: introduce mocking
import 'dart:math';

import 'package:cramr_ui_lib/model/verb_test_model.dart';
import 'package:cramr_ui_lib/routes/verb_indicative_test_route.dart';
import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:provider/provider.dart';

var expected = ['expect-p0', 'expect-p1', 'expect-p2', 'expect-p3', 'expect-p4', 'expect-p5'];
var pronouns = ['p0', 'p1', 'p2', 'p3', 'p4', 'p5'];
var targetLanguageIso = 'zz';
var infinitive = 'infinitive';
var translation = 'translation';

Widget createVerbIndicativeTestRoute() => ChangeNotifierProvider<VerbTestModel> (
  create: (context) {
    var notifier = VerbTestModel();
    notifier.initialise(expected, pronouns, targetLanguageIso, infinitive, translation);
    return notifier;
  },
  child: VerbIndicativeTestRoute(),
);

void main() {
  testWidgets('Find elements on screen', (WidgetTester tester) async {
    await tester.pumpWidget(createVerbIndicativeTestRoute());

    Finder titleFinder = find.text('Vervoeging ${infinitive}');
    expect(titleFinder, findsOneWidget);

    pronouns.forEach((element) {
      final Finder pronounFinder = find.text(element);
      expect(pronounFinder, findsOneWidget);
    });

    for (int i = 0; i < expected.length; i++) {
      Finder textFieldFinder = find.byKey(Key('test_${infinitive}_${i}'));
      expect(textFieldFinder, findsOneWidget);
    }

  });

}